      SUBROUTINE DSORT
*     SORT AND PRINT OUT INTERATOMIC DISTANCES FOR ATOMS IN 
*     THE ASYMMETRIC UNIT
*     FILE #5 WAS CHANGED INTO #3
*      INPUT: FILE #3 (STANDARD INPUT = OUTPUT FROM ORFFE)
*     OUTPUT: FILE #6 (STANDARD OUTPUT)
*     OUTPUT: FILE #4 (OUTPUT FILE WITH NO CARRIAGE CONTROL)
*     MDIST: MAXIMUM INTERATOMIC DISTANCES
*     MCN: MAXIMUM COORDINATION NUMBER
      PARAMETER (MDIST=10000,MCN=500)
      INTEGER IN(4,MDIST),NUM(MCN),IOUT(MCN)
      REAL XYZ(6,MDIST),DIST(3,MDIST)
      CHARACTER ATOMN(2,MDIST)*9,LINE*137,FNAME*50
      LOGICAL LEXIST,LOOP
      COMMON /MATER/ FNAME
       
      REWIND 3
      CALL OPEN4(LEXIST)

*     READ THE NUMBER OF ATOMS IN THE ASYMMETRIC UNIT
      DO I=1,100000
         READ(3,'(A)') LINE
         CALL WR46(LINE,LEXIST)
         IF (LINE(1:3) .EQ. '  1') THEN
            DO J=2,500
               READ(3,'(A)') LINE
               CALL WR46(LINE,LEXIST)
               READ(LINE,'(I3)') NATOM
               IF (NATOM .EQ. 0) GO TO 1
            END DO
         END IF
      END DO
    1 NATOM=J-1
  
      DO I=1,100000
         READ(3,'(A)') LINE
         CALL WR46(LINE,LEXIST)
         IF (LINE(1:35) .EQ.  '0INTERATOMIC DISTANCE IN ANGSTROMS ')
     &   EXIT
      END DO

      J=1
      DO IJ = 1, 100000
         READ(3,100,END=6) (IN(I,J),I=1,4),ATOMN(1,J),
     &   (XYZ(I,J),I=1,3),ATOMN(2,J),(XYZ(I,J),I=4,6)
  100    FORMAT(12X,I2,1X,I5,3X,I2,1X,I5,25X,A9,
     &   2X,F7.4,1X,F8.4,1X,F8.4,5X,A9,2X,F7.4,1X,F8.4,1X,F8.4)
         IF (IN(1,J) .EQ. 0) EXIT
         READ(3,'(53X,F9.4,5X,F7.4,2X,F7.4)') (DIST(I,J),I=1,3)
*        SKIP IF THE INTERATOMIC DISTANCE IS ZERO
         IF (DIST(1,J) .EQ. 0.0) CYCLE

*        SWAP A PAIR OF ATOMS IF THE 2ND ATOM IS IN THE ASYMMETRIC UNIT
         IF (IN(4,J) .EQ. 0) THEN
            IN(1,J+1)=IN(3,J)
            IN(2,J+1)=IN(4,J)
            IN(3,J+1)=IN(1,J)
            IN(4,J+1)=IN(2,J)
            ATOMN(1,J+1)=ATOMN(2,J)
            ATOMN(2,J+1)=ATOMN(1,J)
            XYZ(1,J+1)=XYZ(4,J)
            XYZ(2,J+1)=XYZ(5,J)
            XYZ(3,J+1)=XYZ(6,J)
            XYZ(4,J+1)=XYZ(1,J)
            XYZ(5,J+1)=XYZ(2,J)
            XYZ(6,J+1)=XYZ(3,J)
            DIST(1,J+1)=DIST(1,J)
            DIST(2,J+1)=DIST(2,J)
            DIST(3,J+1)=DIST(3,J)
            J=J+1
         END IF
         J=J+1
         IF (J. GT. MDIST-1) THEN
            WRITE(6,'(A)') ' INCREASE MDIST'
            STOP
         END IF
      END DO
    6 NDIST=J-1

*     IORDER: SERIES NUMBERS FOR INTERATOMIC DISTANCES AND BOND ANGLES
      IORDER=1
      DO I=1,NATOM
         INUM=1
         DO J=1,NDIST
            IF (IN(1,J) .EQ. I) THEN
               NUM(INUM)=J
*              IOUT = 0: THIS DISTANCE HAS NOT BEEN PRINTED OUT
*              IOUT = 1: THIS DISTANCE HAS ALREADY BEEN PRINTED OUT
               IOUT(INUM)=0
               INUM=INUM+1
               IF (INUM .GT. MCN) THEN
                  WRITE(6,'(A)') ' INCREASE MCN'
                  STOP
               END IF
            END IF
         END DO
         INUM=INUM-1
         IF (INUM .EQ. 0) CYCLE

*        EXTREMELY LONG DISTANCE (DUMMY)
         LOOP = .TRUE.
	 DO WHILE (LOOP)
            DMIN=10000.0
            DO J=1,INUM 
               IF (IOUT(J) .EQ. 0 .AND. DIST(1,NUM(J)) .LT. DMIN) THEN
                  DMIN=DIST(1,NUM(J))
                  JOUT=J
               END IF
            END DO
         
            IF (ABS(DMIN-10000.0) .LT. 0.1) THEN
               WRITE(LINE,'(1H0,129A1)') ('-',j=1,129)
	       CALL WR46(LINE,LEXIST)
	       LOOP = .FALSE.
            ELSE
               WRITE(LINE,150) IORDER,(IN(J,NUM(JOUT)),J=1,4),
     &         ATOMN(1,NUM(JOUT)),(XYZ(J,NUM(JOUT)),J=1,3),
     &         ATOMN(2,NUM(JOUT)),(XYZ(J,NUM(JOUT)),J=4,6)
               CALL WR46(LINE,LEXIST)
  150          FORMAT('0',I5,5X,'(',I2,1H,I5,3H) (I2,1H,I5,1H),24X,A9,
     &         ' (',F7.4,',',F8.4,',',F8.4,');   ',A9,' (',F7.4,',',
     &         F8.4,',',F8.4,')')
               WRITE(LINE,'(1H 52X,F9.4,5H +OR-F7.4,2H (F7.4,1H))') 
     &         (DIST(J,NUM(JOUT)),J=1,3) 
               CALL WR46(LINE,LEXIST)
               IOUT(JOUT)=1
               IORDER=IORDER+1
            END IF
	 END DO
      END DO

      IF (.NOT. LEXIST) WRITE(4,'()')
      WRITE(6,'()')
      DO I=1,10000
         READ(3,'(A)',END=9) LINE
         IF (LINE(12:12) .EQ. '(') THEN
            WRITE(LINE,'(A,I5,5X,A)') '0',IORDER,LINE(12:)
            CALL WR46(LINE,LEXIST)
            IORDER=IORDER+1
         ELSE
            CALL WR46(LINE,LEXIST)         
         END IF
      END DO
    9 CLOSE(UNIT=3)
      IF (.NOT. LEXIST) CLOSE(UNIT=4)
      CLOSE(UNIT=6)
      END
    
      SUBROUTINE WR46(LINE,LEXIST)
      CHARACTER*(*) LINE
      LOGICAL LEXIST
      
      IF (.NOT. LEXIST) WRITE(4,'(A)') LINE
      WRITE(6,'(A)') LINE
      END
      

